#include "LCD232.h"		// " ist ok!!

#include "Single.h"

// Globale Variblen zwecks Datenaustausch der ISRs
	volatile unsigned char a,Data_LCD= FALSE ,STATE_TX = 1,STATE_RX = 1;

void InitUART_LCD(void)		
{
UBRR0H = ((F_CPU / (16UL * UART_BAUD)) - 1 )>> 8;
UBRR0L = ((F_CPU / (16UL * UART_BAUD)) - 1);
UCSR0B = (1<<RXEN0)|(1<<TXEN0);//| (1<<RXCIE0)|(1<<TXCIE0); 
UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);// Asynchron 8N1
}

unsigned char ReceiveByte_LCD( void )
{
/* Wait for data to be received */
while (!(UCSR0A & (1<<RXC0)) );
/* Get and return received data from buffer */
return UDR0;
}


// --- transmit a byte
void TransmitByte_LCD(unsigned char data)
{
//wann darf ich loslegen? 
while(!(UCSR0A & (1<<UDRE0))); 
UDR0 = data; //transmit data

}



// Abfrage ob Nutzdaten bereit sind und wieviele Bytes zur Abholung bereit stehen
unsigned char get_Puffer_Bytes_LCD()
{
unsigned char Puffer_Data[Ct_Data],i;
unsigned int sum=0;
	
		smallprot_receive(2,1,'I');		//Abfrage ob Nutzdaten bereit sind

		if (ReceiveByte_LCD() == ACK)  // Daten am LCD korrekt empfangen?
			{
			for(i=0;i<Ct_Data;i++)	   //Falls ja, dann Daten auslesen	
				{
				Puffer_Data[i] = ReceiveByte_LCD();
				// Summe fr Prfsumme bilden			
				sum += Puffer_Data[i];
				}		

			sum = sum - Puffer_Data[(Ct_Data-1)] ;  // BCC abziehen
			sum = (unsigned char) sum;				// berlauf entfernen

			if (sum == Puffer_Data[Ct_Data-1])	//Prfsumme vergleichen
				{
				return (Puffer_Data[2]+ 3);		//Rckgabe der abholbereiten Bytes, inklusive Header(Daten!)
				}
			else	//Fehlerhafte bermittlung
				{
				return FALSECHECKSUM;
				}			

			}
		else	// Daten am LCD nicht verstanden 
			{
			return NOCONNECTION ;
			}

}

// Empfangen der Daten aus dem Datenpuffer
void Puffer_LCD(unsigned char *Puffer_Data)
{
unsigned char Bytes_free;
unsigned int sum=0,i;
	
	
Bytes_free = get_Puffer_Bytes_LCD(); // Abfragen der abholbereiten Bytes

		smallprot_receive(2,1,'S');		//Anfordern der Daten aus dem Datenpuffer des LCD

		if (ReceiveByte_LCD() == ACK)  // Daten am LCD korrekt empfangen?
			{
			for(i=0;i<Bytes_free;i++)  //Falls ja, dann Daten auslesen
				{
				Puffer_Data[i] = ReceiveByte_LCD();
				// Summe fr Prfsumme bilden			
				sum += Puffer_Data[i];
				}	
				sum = sum - Puffer_Data[(Bytes_free-1)] ; 	// BCC abziehen
				sum = (unsigned char) sum;
	
				if (sum == Puffer_Data[(Bytes_free-1)])	//Prfsumme vergleichen
					{
					//show_content(150,50,'H');//	 Absolut OK!
					}
				else	//Fehlerhafte bermittlung
					{
					//return FALSECHECKSUM;
					//show_content(70,50,'A');//	 Absolut OK!
					}	
	
				}
			else
				{
				//return NOCONNECTION ;
				}	

			for(i=0;i<6;i++) 
				{

				show_content(50 +(i*20),150,0x30 +Puffer_Data[i]);
				}

}


unsigned char get_Return_Code_LCD()
{
unsigned char Data[7],i;
//0 = DC1
//1 = len
//2 = ESC 
//3 = A
//4 = 1
//5 = Code Return
//6 = BCC


	if (!(PIND & (1<<PIND0)) )   //Daten zum Auslesen bereit? PIND0 = LOW
		{ 
		Puffer_LCD(Data);	// Daten aus Puffer laden
		}

return Data[CODERET];		// Return-Code/(Touchmakro-X) 
}


void show_content(unsigned char xx_start,unsigned char yy_start,unsigned char Data)
{
unsigned char xxa_start,xxb_start,yya_start,yyb_start;

// Shiften fr ntige bergabe nach Smallprotokoll-Definition
xxa_start = (xx_start);
xxb_start = (xx_start >> 8);
yya_start = (yy_start);
yyb_start = (yy_start >> 8);

//Senden der Daten an Stelle XX,YY

smallprot_send(8,'Z','L',xxa_start,xxb_start,yya_start,yyb_start,Data,CR);



}





void smallprot_send(unsigned char Parameter_Nrs, ...)
{
	// 1 Wegen True draufaddieren, sonst 0te Element False!
	// +4 --> zuzglich Header(DC1, len, ESC, BCC )
	unsigned char i=1,Count = (Parameter_Nrs +1), Parameter[(Parameter_Nrs + 4)];	
	unsigned int bcc=0;

	// Erstellen des Protokoll-Prefix
	Parameter[0] = DC1;	
	//Anzahl der Nutzdaten in Byte
	Parameter[1] = Count;
	// Esc-Sequence
	Parameter[2] = ESC;

      va_list parg;			// Parameterliste erzeugen
      
	  if (Parameter_Nrs)	// berhaupt Parameter enthalten?
	  	{
		va_start (parg, Parameter_Nrs);	// Initialisierung der freien Parameter-Anzahl-Funktion
			while(Parameter_Nrs--)
				{
				// nchsten Wert vom Stack holen
				Parameter[(2+i)] = va_arg(parg,int);
				//Berechnung der Prfsumme
				bcc += Parameter[(2+i)];   		// Korrekter endwert
				i +=  1;
				}
			va_end(parg);						//Aufrumarbeiten
		}
    else
		{
		// Meldung noch generieren, LED ausgeben oder hnliches!!!
		}
	bcc = bcc + DC1 + Count+ ESC;


	bcc = (unsigned char)bcc;	
	// Prfsumme zuweisen
	Parameter[(Count+2)] = bcc;

	for(i=0;i<(sizeof(Parameter));i++)
		{
		TransmitByte_LCD(Parameter[i]);
		}						
		delay_timer(350);		// Timeout-Zeit
}

void smallprot_receive(unsigned char Parameter_Nrs, ...)
{

	unsigned char i=1,Parameter[(Parameter_Nrs + 2)],count = Parameter_Nrs;
	unsigned int bcc=0;

	// Erstellen des Protokoll-Prefix
	Parameter[0] = DC2;
	
      va_list parg;		// Zeiger auf Parameter
      
	  if (Parameter_Nrs)	// berhaupt Parameter enthalten?
	  	{
		va_start (parg, Parameter_Nrs);	// Initialisierung der freien Parameter-Anzahl-Funktion
			while(Parameter_Nrs--)
				{
				// nchsten Wert vom Stack holen
				Parameter[(i)] = (unsigned char) va_arg(parg,int);
				//Berechnung der Prfsumme
				bcc += Parameter[(i)];   		// Korrekter endwert
				i +=  1;
				}
			va_end(parg);						//Aufrumarbeiten
		}
    else
		{
		// Meldung noch generieren, LED ausgeben oder hnliches!!!
		}
	bcc = bcc + DC2 ;//+ Count+ ESC;
	
	// Abschneiden 
	bcc = (unsigned char)bcc;	
	// Prfsumme zuweisen

	Parameter[(count+1)] = bcc;

	for(i=0;i<(sizeof(Parameter));i++)
		{
		TransmitByte_LCD(Parameter[i]); 
		}
	

}
/*
//wenn ungelesene Daten erhalten sind! 
ISR (USART0_RX_vect) 
{
	STATE_RX ^= 1;
}

ISR (USART0_TX_vect) 
{
	STATE_TX ^= 1;
}
 */
